Loading...
Searching...
No Matches
juce::Time Class Reference

## Detailed Description

Holds an absolute date and time.

Internally, the time is stored at millisecond precision.

See also
  RelativeTime

The documentation for this class was generated from the following file:

- juce_core/time/juce_Time.h

## Public Member Functions

| Time ()=default
| Creates a Time object.
| Time (int64 millisecondsSinceEpoch) noexcept
| Creates a time based on a number of milliseconds.
template<typename Clock>
| Time (std::chrono::time_point< Clock > timePoint) noexcept
| Creates a Time from a std::chrono::time_point.
| Time (int year, int month, int day, int hours, int minutes, int seconds=0, int milliseconds=0, bool useLocalTime=true) noexcept
| Creates a time from a set of date components.
| Time (const Time &)=default
| ~Time ()=default
Time & | operator= (const Time &)=default
int64 | toMilliseconds () const noexcept
| Returns the time as a number of milliseconds.
template<typename TimeUnit>
auto | countDurationSinceEpochIn () const noexcept
| Returns the time since the Unix epoch expressed in the requested time unit.
template<typename Clock>
auto | toStdTimePoint () const noexcept
| Converts this Time to a std::chrono::time_point.
int | getYear () const noexcept
| Returns the year (in this machine's local timezone).
int | getMonth () const noexcept
| Returns the number of the month (in this machine's local timezone).
String | getMonthName (bool threeLetterVersion) const
| Returns the name of the month (in this machine's local timezone).
int | getDayOfMonth () const noexcept
| Returns the day of the month (in this machine's local timezone).
int | getDayOfWeek () const noexcept
| Returns the number of the day of the week (in this machine's local timezone).
int | getDayOfYear () const noexcept
| Returns the number of the day of the year (in this machine's local timezone).
String | getWeekdayName (bool threeLetterVersion) const
| Returns the name of the weekday (in this machine's local timezone).
int | getHours () const noexcept
| Returns the number of hours since midnight (in this machine's local timezone).
bool | isAfternoon () const noexcept
| Returns true if the time is in the afternoon (in this machine's local timezone).
int | getHoursInAmPmFormat () const noexcept
| Returns the hours in 12-hour clock format (in this machine's local timezone).
int | getMinutes () const noexcept
| Returns the number of minutes, 0 to 59 (in this machine's local timezone).
int | getSeconds () const noexcept
| Returns the number of seconds, 0 to 59.
int | getMilliseconds () const noexcept
| Returns the number of milliseconds, 0 to 999.
bool | isDaylightSavingTime () const noexcept
| Returns true if the local timezone uses a daylight saving correction.
String | getTimeZone () const
| Returns a 3-character string to indicate the local timezone.
int | getUTCOffsetSeconds () const noexcept
| Returns the local timezone offset from UTC in seconds.
String | getUTCOffsetString (bool includeDividerCharacters) const
| Returns a string to indicate the offset of the local timezone from UTC.
String | toString (bool includeDate, bool includeTime, bool includeSeconds=true, bool use24HourClock=false) const
| Returns a string version of this date and time, using this machine's local timezone.
String | formatted (const String &format) const
| Converts this date/time to a string with a user-defined format.
String | toISO8601 (bool includeDividerCharacters) const
| Returns a fully described string of this date and time in ISO-8601 format (using the local timezone).
Time & | operator+= (RelativeTime delta) noexcept
| Adds a RelativeTime to this time.
Time & | operator-= (RelativeTime delta) noexcept
| Subtracts a RelativeTime from this time.
bool | setSystemTimeToThisTime () const
| Tries to set the computer's clock.

## Static Public Member Functions

static Time JUCE_CALLTYPE | getCurrentTime () noexcept
| Returns a Time object that is set to the current system time.
static Time | fromISO8601 (StringRef iso8601)
| Parses an ISO-8601 string and returns it as a Time.
static String | getWeekdayName (int dayNumber, bool threeLetterVersion)
| Returns the name of a day of the week.
static String | getMonthName (int monthNumber, bool threeLetterVersion)
| Returns the name of one of the months.
static int64 | currentTimeMillis () noexcept
| Returns the current system time.
static uint32 | getMillisecondCounter () noexcept
| Returns the number of millisecs since a fixed event (usually system startup).
static double | getMillisecondCounterHiRes () noexcept
| Returns the number of millisecs since a fixed event (usually system startup).
static void | waitForMillisecondCounter (uint32 targetTime) noexcept
| Waits until the getMillisecondCounter() reaches a given value.
static uint32 | getApproximateMillisecondCounter () noexcept
| Less-accurate but faster version of getMillisecondCounter().
static int64 | getHighResolutionTicks () noexcept
| Returns the current high-resolution counter's tick-count.
static int64 | getHighResolutionTicksPerSecond () noexcept
| Returns the resolution of the high-resolution counter in ticks per second.
static double | highResolutionTicksToSeconds (int64 ticks) noexcept
| Converts a number of high-resolution ticks into seconds.
static int64 | secondsToHighResolutionTicks (double seconds) noexcept
| Converts a number seconds into high-resolution ticks.
static Time | getCompilationDate ()
| Returns a Time based on the value of the DATE macro when this module was compiled.

## Constructors and Destructors

## Time() [1/5]

juce::Time::Time | ( |  | ) |

default

Creates a Time object.

This default constructor creates a time of midnight Jan 1st 1970 UTC, (which is represented internally as 0ms). To create a time object representing the current time, use getCurrentTime().

See also
  getCurrentTime

Referenced by fromISO8601(), getCompilationDate(), getCurrentTime(), operator+=(), operator-=(), operator=(), Time(), Time(), and ~Time().

## Time() [2/5]

juce::Time::Time | ( | int64 | millisecondsSinceEpoch | ) |

explicit noexcept

Creates a time based on a number of milliseconds.

To create a time object set to the current time, use getCurrentTime().

Parameters

  millisecondsSinceEpoch | the number of milliseconds since the unix 'epoch' (midnight Jan 1st 1970 UTC).

See also
  getCurrentTime, currentTimeMillis

## Time() [3/5]

template<typename Clock>

juce::Time::Time | ( | std::chrono::time_point< Clock > | timePoint | ) |

inline explicit noexcept

Creates a Time from a std::chrono::time_point.

References Time().

## Time() [4/5]

juce::Time::Time | ( | int | year,
|  | int | month,
|  | int | day,
|  | int | hours,
|  | int | minutes,
|  | int | seconds = 0,
|  | int | milliseconds = 0,
|  | bool | useLocalTime = true )

noexcept

Creates a time from a set of date components.

Parameters

  year | the year, in 4-digit format, e.g. 2004
  month | the month, in the range 0 to 11
  day | the day of the month, in the range 1 to 31
  hours | hours in 24-hour clock format, 0 to 23
  minutes | minutes 0 to 59
  seconds | seconds 0 to 59
  milliseconds | milliseconds 0 to 999
  useLocalTime | if true, assume input is in this machine's local timezone if false, assume input is in UTC.

## Time() [5/5]

juce::Time::Time | ( | const Time & |  | ) |

default

References Time().

## ~Time()

juce::Time::~Time | ( |  | ) |

default

References Time().

## Member Functions

## operator=()

Time & juce::Time::operator= | ( | const Time & |  | ) |

default

References Time().

## getCurrentTime()

Time JUCE_CALLTYPE juce::Time::getCurrentTime | ( |  | ) |

static noexcept

Returns a Time object that is set to the current system time.

This may not be monotonic, as the system time can change at any moment. You should therefore not use this method for measuring time intervals.

See also
  currentTimeMillis

References getCurrentTime(), JUCE_CALLTYPE, and Time().

Referenced by getCurrentTime().

## toMilliseconds()

int64 juce::Time::toMilliseconds | ( |  | ) | const

inline noexcept

Returns the time as a number of milliseconds.

Returns
  the number of milliseconds this Time object represents, since midnight Jan 1st 1970 UTC.

See also
  getMilliseconds

References toMilliseconds().

Referenced by toMilliseconds().

## countDurationSinceEpochIn()

template<typename TimeUnit>

auto juce::Time::countDurationSinceEpochIn | ( |  | ) | const

inline noexcept

Returns the time since the Unix epoch expressed in the requested time unit.

## toStdTimePoint()

template<typename Clock>

auto juce::Time::toStdTimePoint | ( |  | ) | const

inline noexcept

Converts this Time to a std::chrono::time_point.

## getYear()

int juce::Time::getYear | ( |  | ) | const

noexcept

Returns the year (in this machine's local timezone).

A 4-digit format is used, e.g. 2004.

## getMonth()

int juce::Time::getMonth | ( |  | ) | const

noexcept

Returns the number of the month (in this machine's local timezone).

The value returned is in the range 0 to 11.

See also
  getMonthName

References getMonth().

Referenced by getMonth().

## getMonthName() [1/2]

String juce::Time::getMonthName | ( | bool | threeLetterVersion | ) | const

Returns the name of the month (in this machine's local timezone).

Parameters

  threeLetterVersion | if true, it'll be a 3-letter abbreviation, e.g. "Jan"; if false it'll return the long form, e.g. "January"

See also
  getMonth

References getMonthName().

Referenced by getMonthName(), and getMonthName().

## getDayOfMonth()

int juce::Time::getDayOfMonth | ( |  | ) | const

noexcept

Returns the day of the month (in this machine's local timezone).

The value returned is in the range 1 to 31.

References getDayOfMonth().

Referenced by getDayOfMonth().

## getDayOfWeek()

int juce::Time::getDayOfWeek | ( |  | ) | const

noexcept

Returns the number of the day of the week (in this machine's local timezone).

The value returned is in the range 0 to 6 (0 = sunday, 1 = monday, etc).

References getDayOfWeek().

Referenced by getDayOfWeek().

## getDayOfYear()

int juce::Time::getDayOfYear | ( |  | ) | const

noexcept

Returns the number of the day of the year (in this machine's local timezone).

The value returned is in the range 0 to 365.

References getDayOfYear().

Referenced by getDayOfYear().

## getWeekdayName() [1/2]

String juce::Time::getWeekdayName | ( | bool | threeLetterVersion | ) | const

Returns the name of the weekday (in this machine's local timezone).

Parameters

  threeLetterVersion | if true, it'll return a 3-letter abbreviation, e.g. "Tue"; if false, it'll return the full version, e.g. "Tuesday".

References getWeekdayName().

Referenced by getWeekdayName(), and getWeekdayName().

## getHours()

int juce::Time::getHours | ( |  | ) | const

noexcept

Returns the number of hours since midnight (in this machine's local timezone).

This is in 24-hour clock format, in the range 0 to 23.

See also
  getHoursInAmPmFormat, isAfternoon

References getHours().

Referenced by getHours().

## isAfternoon()

bool juce::Time::isAfternoon | ( |  | ) | const

noexcept

Returns true if the time is in the afternoon (in this machine's local timezone).

Returns
  true for "PM", false for "AM".

See also
  getHoursInAmPmFormat, getHours

References isAfternoon().

Referenced by isAfternoon().

## getHoursInAmPmFormat()

int juce::Time::getHoursInAmPmFormat | ( |  | ) | const

noexcept

Returns the hours in 12-hour clock format (in this machine's local timezone).

This will return a value 1 to 12 - use isAfternoon() to find out whether this is in the afternoon or morning.

See also
  getHours, isAfternoon

References getHoursInAmPmFormat().

Referenced by getHoursInAmPmFormat().

## getMinutes()

int juce::Time::getMinutes | ( |  | ) | const

noexcept

Returns the number of minutes, 0 to 59 (in this machine's local timezone).

References getMinutes().

Referenced by getMinutes().

## getSeconds()

int juce::Time::getSeconds | ( |  | ) | const

noexcept

Returns the number of seconds, 0 to 59.

References getSeconds().

Referenced by getSeconds().

## getMilliseconds()

int juce::Time::getMilliseconds | ( |  | ) | const

noexcept

Returns the number of milliseconds, 0 to 999.

Unlike toMilliseconds(), this just returns the position within the current second rather than the total number since the epoch.

See also
  toMilliseconds

References getMilliseconds().

Referenced by getMilliseconds().

## isDaylightSavingTime()

bool juce::Time::isDaylightSavingTime | ( |  | ) | const

noexcept

Returns true if the local timezone uses a daylight saving correction.

References isDaylightSavingTime().

Referenced by isDaylightSavingTime().

## getTimeZone()

String juce::Time::getTimeZone | ( |  | ) | const

Returns a 3-character string to indicate the local timezone.

References getTimeZone().

Referenced by getTimeZone().

## getUTCOffsetSeconds()

int juce::Time::getUTCOffsetSeconds | ( |  | ) | const

noexcept

Returns the local timezone offset from UTC in seconds.

References getUTCOffsetSeconds().

Referenced by getUTCOffsetSeconds().

## getUTCOffsetString()

String juce::Time::getUTCOffsetString | ( | bool | includeDividerCharacters | ) | const

Returns a string to indicate the offset of the local timezone from UTC.

Returns
  "+XX:XX", "-XX:XX" or "Z"

Parameters

  includeDividerCharacters | whether to include or omit the ":" divider in the string

References getUTCOffsetString().

Referenced by getUTCOffsetString().

## toString()

String juce::Time::toString | ( | bool | includeDate,
|  | bool | includeTime,
|  | bool | includeSeconds = true,
|  | bool | use24HourClock = false ) const

Returns a string version of this date and time, using this machine's local timezone.

For a more powerful way of formatting the date and time, see the formatted() method.

Parameters

  includeDate | whether to include the date in the string
  includeTime | whether to include the time in the string
  includeSeconds | if the time is being included, this provides an option not to include the seconds in it
  use24HourClock | if the time is being included, sets whether to use am/pm or 24 hour notation.

See also
  formatted

References toString().

Referenced by toString().

## formatted()

String juce::Time::formatted | ( | const String & | format | ) | const

Converts this date/time to a string with a user-defined format.

This uses the C strftime() function to format this time as a string. To save you looking it up, these are the escape codes that strftime uses (other codes might work on some platforms and not others, but these are the common ones):

- a is replaced by the locale's abbreviated weekday name.
- A is replaced by the locale's full weekday name.
- b is replaced by the locale's abbreviated month name.
- B is replaced by the locale's full month name.
- c is replaced by the locale's appropriate date and time representation.
- d is replaced by the day of the month as a decimal number [01,31].
- H is replaced by the hour (24-hour clock) as a decimal number [00,23].
- I is replaced by the hour (12-hour clock) as a decimal number [01,12].
- j is replaced by the day of the year as a decimal number [001,366].
- m is replaced by the month as a decimal number [01,12].
- M is replaced by the minute as a decimal number [00,59].
- p is replaced by the locale's equivalent of either a.m. or p.m.
- S is replaced by the second as a decimal number [00,60].
- U is replaced by the week number of the year (Sunday as the first day of the week) as a decimal number [00,53].
- w is replaced by the weekday as a decimal number [0,6], with 0 representing Sunday.
- W is replaced by the week number of the year (Monday as the first day of the week) as a decimal number [00,53]. All days in a new year preceding the first Monday are considered to be in week 0.
- x is replaced by the locale's appropriate date representation.
- X is replaced by the locale's appropriate time representation.
- y is replaced by the year without century as a decimal number [00,99].
- Y is replaced by the year with century as a decimal number.
- Z is replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists.
- %% is replaced by %.

See also
  toString

References formatted().

Referenced by formatted().

## toISO8601()

String juce::Time::toISO8601 | ( | bool | includeDividerCharacters | ) | const

Returns a fully described string of this date and time in ISO-8601 format (using the local timezone).

Parameters

  includeDividerCharacters | whether to include or omit the "-" and ":" dividers in the string

References toISO8601().

Referenced by toISO8601().

## fromISO8601()

Time juce::Time::fromISO8601 | ( | StringRef | iso8601 | ) |

static

Parses an ISO-8601 string and returns it as a Time.

References fromISO8601(), and Time().

Referenced by fromISO8601().

## operator+=()

Time & juce::Time::operator+= | ( | RelativeTime | delta | ) |

noexcept

Adds a RelativeTime to this time.

References Time().

## operator-=()

Time & juce::Time::operator-= | ( | RelativeTime | delta | ) |

noexcept

Subtracts a RelativeTime from this time.

References Time().

## setSystemTimeToThisTime()

bool juce::Time::setSystemTimeToThisTime | ( |  | ) | const

Tries to set the computer's clock.

Returns
  true if this succeeds, although depending on the system, the application might not have sufficient privileges to do this.

References setSystemTimeToThisTime().

Referenced by setSystemTimeToThisTime().

## getWeekdayName() [2/2]

String juce::Time::getWeekdayName | ( | int | dayNumber,
|  | bool | threeLetterVersion )

static

Returns the name of a day of the week.

Parameters

  dayNumber | the day, 0 to 6 (0 = sunday, 1 = monday, etc)
  threeLetterVersion | if true, it'll return a 3-letter abbreviation, e.g. "Tue"; if false, it'll return the full version, e.g. "Tuesday".

References getWeekdayName().

## getMonthName() [2/2]

String juce::Time::getMonthName | ( | int | monthNumber,
|  | bool | threeLetterVersion )

static

Returns the name of one of the months.

Parameters

  monthNumber | the month, 0 to 11
  threeLetterVersion | if true, it'll be a 3-letter abbreviation, e.g. "Jan"; if false it'll return the long form, e.g. "January"

References getMonthName().

## currentTimeMillis()

int64 juce::Time::currentTimeMillis | ( |  | ) |

static noexcept

Returns the current system time.

Returns the number of milliseconds since midnight Jan 1st 1970 UTC.

Should be accurate to within a few millisecs, depending on platform, hardware, etc.

References currentTimeMillis().

Referenced by currentTimeMillis().

## getMillisecondCounter()

uint32 juce::Time::getMillisecondCounter | ( |  | ) |

static noexcept

Returns the number of millisecs since a fixed event (usually system startup).

This returns a monotonically increasing value which is unaffected by changes to the system clock. It should be accurate to within a few millisecs, depending on platform, hardware, etc.

Being a 32-bit return value, it will of course wrap back to 0 after 2^32 seconds of uptime, so be careful to take that into account. If you need a 64-bit time, you can use currentTimeMillis() instead.

See also
  getApproximateMillisecondCounter

References getMillisecondCounter().

Referenced by getMillisecondCounter().

## getMillisecondCounterHiRes()

double juce::Time::getMillisecondCounterHiRes | ( |  | ) |

static noexcept

Returns the number of millisecs since a fixed event (usually system startup).

This has the same function as getMillisecondCounter(), but returns a more accurate value, using a higher-resolution timer if one is available.

See also
  getMillisecondCounter

References getMillisecondCounterHiRes().

Referenced by getMillisecondCounterHiRes().

## waitForMillisecondCounter()

void juce::Time::waitForMillisecondCounter | ( | uint32 | targetTime | ) |

static noexcept

Waits until the getMillisecondCounter() reaches a given value.

This will make the thread sleep as efficiently as it can while it's waiting.

References waitForMillisecondCounter().

Referenced by waitForMillisecondCounter().

## getApproximateMillisecondCounter()

uint32 juce::Time::getApproximateMillisecondCounter | ( |  | ) |

static noexcept

Less-accurate but faster version of getMillisecondCounter().

This will return the last value that getMillisecondCounter() returned, so doesn't need to make a system call, but is less accurate - it shouldn't be more than 100ms away from the correct time, though, so is still accurate enough for a lot of purposes.

See also
  getMillisecondCounter

References getApproximateMillisecondCounter().

Referenced by getApproximateMillisecondCounter().

## getHighResolutionTicks()

int64 juce::Time::getHighResolutionTicks | ( |  | ) |

static noexcept

Returns the current high-resolution counter's tick-count.

This is a similar idea to getMillisecondCounter(), but with a higher resolution.

See also
  getHighResolutionTicksPerSecond, highResolutionTicksToSeconds, secondsToHighResolutionTicks

References getHighResolutionTicks().

Referenced by getHighResolutionTicks(), and juce::ScopedTimeMeasurement::~ScopedTimeMeasurement().

## getHighResolutionTicksPerSecond()

int64 juce::Time::getHighResolutionTicksPerSecond | ( |  | ) |

static noexcept

Returns the resolution of the high-resolution counter in ticks per second.

See also
  getHighResolutionTicks, highResolutionTicksToSeconds, secondsToHighResolutionTicks

References getHighResolutionTicksPerSecond().

Referenced by getHighResolutionTicksPerSecond().

## highResolutionTicksToSeconds()

double juce::Time::highResolutionTicksToSeconds | ( | int64 | ticks | ) |

static noexcept

Converts a number of high-resolution ticks into seconds.

See also
  getHighResolutionTicks, getHighResolutionTicksPerSecond, secondsToHighResolutionTicks

References highResolutionTicksToSeconds().

Referenced by highResolutionTicksToSeconds(), and juce::ScopedTimeMeasurement::~ScopedTimeMeasurement().

## secondsToHighResolutionTicks()

int64 juce::Time::secondsToHighResolutionTicks | ( | double | seconds | ) |

static noexcept

Converts a number seconds into high-resolution ticks.

See also
  getHighResolutionTicks, getHighResolutionTicksPerSecond, highResolutionTicksToSeconds

References secondsToHighResolutionTicks().

Referenced by secondsToHighResolutionTicks().

## getCompilationDate()

Time juce::Time::getCompilationDate | ( |  | ) |

static

Returns a Time based on the value of the DATE macro when this module was compiled.

References getCompilationDate(), and Time().

Referenced by getCompilationDate().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited